package cn.superdesk.uniorder.dao.entity.sys.role;

import java.util.ArrayList;
import java.util.List;

public class SysRoleExtDataSamplePermissionExample {
    /**
     *
     * table sys_role_ext_data_sample_permission
     *
     * Wed Aug 26 11:48:59 CST 2020
     */
    protected String orderByClause;

    /**
     *
     * table sys_role_ext_data_sample_permission
     *
     * Wed Aug 26 11:48:59 CST 2020
     */
    protected boolean distinct;

    /**
     *
     * table sys_role_ext_data_sample_permission
     *
     * Wed Aug 26 11:48:59 CST 2020
     */
    protected List<Criteria> oredCriteria;

    /**
     *
     * table sys_role_ext_data_sample_permission
     *
     * Wed Aug 26 11:48:59 CST 2020
     */
    public SysRoleExtDataSamplePermissionExample() {
        oredCriteria = new ArrayList<>();
    }

    /**
     *
     * table sys_role_ext_data_sample_permission
     *
     * Wed Aug 26 11:48:59 CST 2020
     */
    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    /**
     *
     * table sys_role_ext_data_sample_permission
     *
     * Wed Aug 26 11:48:59 CST 2020
     */
    public String getOrderByClause() {
        return orderByClause;
    }

    /**
     *
     * table sys_role_ext_data_sample_permission
     *
     * Wed Aug 26 11:48:59 CST 2020
     */
    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    /**
     *
     * table sys_role_ext_data_sample_permission
     *
     * Wed Aug 26 11:48:59 CST 2020
     */
    public boolean isDistinct() {
        return distinct;
    }

    /**
     *
     * table sys_role_ext_data_sample_permission
     *
     * Wed Aug 26 11:48:59 CST 2020
     */
    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    /**
     *
     * table sys_role_ext_data_sample_permission
     *
     * Wed Aug 26 11:48:59 CST 2020
     */
    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    /**
     *
     * table sys_role_ext_data_sample_permission
     *
     * Wed Aug 26 11:48:59 CST 2020
     */
    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    /**
     *
     * table sys_role_ext_data_sample_permission
     *
     * Wed Aug 26 11:48:59 CST 2020
     */
    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    /**
     *
     * table sys_role_ext_data_sample_permission
     *
     * Wed Aug 26 11:48:59 CST 2020
     */
    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    /**
     *
     * table sys_role_ext_data_sample_permission
     *
     * Wed Aug 26 11:48:59 CST 2020
     */
    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    /**
     *
     * table sys_role_ext_data_sample_permission
     *
     * Wed Aug 26 11:48:59 CST 2020
     */
    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        public Criteria andIdIsNull() {
            addCriterion("id is null");
            return (Criteria) this;
        }

        public Criteria andIdIsNotNull() {
            addCriterion("id is not null");
            return (Criteria) this;
        }

        public Criteria andIdEqualTo(Long value) {
            addCriterion("id =", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotEqualTo(Long value) {
            addCriterion("id <>", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThan(Long value) {
            addCriterion("id >", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThanOrEqualTo(Long value) {
            addCriterion("id >=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThan(Long value) {
            addCriterion("id <", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThanOrEqualTo(Long value) {
            addCriterion("id <=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdIn(List<Long> values) {
            addCriterion("id in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotIn(List<Long> values) {
            addCriterion("id not in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdBetween(Long value1, Long value2) {
            addCriterion("id between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotBetween(Long value1, Long value2) {
            addCriterion("id not between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andServiceNoIsNull() {
            addCriterion("service_no is null");
            return (Criteria) this;
        }

        public Criteria andServiceNoIsNotNull() {
            addCriterion("service_no is not null");
            return (Criteria) this;
        }

        public Criteria andServiceNoEqualTo(String value) {
            addCriterion("service_no =", value, "serviceNo");
            return (Criteria) this;
        }

        public Criteria andServiceNoNotEqualTo(String value) {
            addCriterion("service_no <>", value, "serviceNo");
            return (Criteria) this;
        }

        public Criteria andServiceNoGreaterThan(String value) {
            addCriterion("service_no >", value, "serviceNo");
            return (Criteria) this;
        }

        public Criteria andServiceNoGreaterThanOrEqualTo(String value) {
            addCriterion("service_no >=", value, "serviceNo");
            return (Criteria) this;
        }

        public Criteria andServiceNoLessThan(String value) {
            addCriterion("service_no <", value, "serviceNo");
            return (Criteria) this;
        }

        public Criteria andServiceNoLessThanOrEqualTo(String value) {
            addCriterion("service_no <=", value, "serviceNo");
            return (Criteria) this;
        }

        public Criteria andServiceNoLike(String value) {
            addCriterion("service_no like", value, "serviceNo");
            return (Criteria) this;
        }

        public Criteria andServiceNoNotLike(String value) {
            addCriterion("service_no not like", value, "serviceNo");
            return (Criteria) this;
        }

        public Criteria andServiceNoIn(List<String> values) {
            addCriterion("service_no in", values, "serviceNo");
            return (Criteria) this;
        }

        public Criteria andServiceNoNotIn(List<String> values) {
            addCriterion("service_no not in", values, "serviceNo");
            return (Criteria) this;
        }

        public Criteria andServiceNoBetween(String value1, String value2) {
            addCriterion("service_no between", value1, value2, "serviceNo");
            return (Criteria) this;
        }

        public Criteria andServiceNoNotBetween(String value1, String value2) {
            addCriterion("service_no not between", value1, value2, "serviceNo");
            return (Criteria) this;
        }

        public Criteria andServiceNameIsNull() {
            addCriterion("service_name is null");
            return (Criteria) this;
        }

        public Criteria andServiceNameIsNotNull() {
            addCriterion("service_name is not null");
            return (Criteria) this;
        }

        public Criteria andServiceNameEqualTo(String value) {
            addCriterion("service_name =", value, "serviceName");
            return (Criteria) this;
        }

        public Criteria andServiceNameNotEqualTo(String value) {
            addCriterion("service_name <>", value, "serviceName");
            return (Criteria) this;
        }

        public Criteria andServiceNameGreaterThan(String value) {
            addCriterion("service_name >", value, "serviceName");
            return (Criteria) this;
        }

        public Criteria andServiceNameGreaterThanOrEqualTo(String value) {
            addCriterion("service_name >=", value, "serviceName");
            return (Criteria) this;
        }

        public Criteria andServiceNameLessThan(String value) {
            addCriterion("service_name <", value, "serviceName");
            return (Criteria) this;
        }

        public Criteria andServiceNameLessThanOrEqualTo(String value) {
            addCriterion("service_name <=", value, "serviceName");
            return (Criteria) this;
        }

        public Criteria andServiceNameLike(String value) {
            addCriterion("service_name like", value, "serviceName");
            return (Criteria) this;
        }

        public Criteria andServiceNameNotLike(String value) {
            addCriterion("service_name not like", value, "serviceName");
            return (Criteria) this;
        }

        public Criteria andServiceNameIn(List<String> values) {
            addCriterion("service_name in", values, "serviceName");
            return (Criteria) this;
        }

        public Criteria andServiceNameNotIn(List<String> values) {
            addCriterion("service_name not in", values, "serviceName");
            return (Criteria) this;
        }

        public Criteria andServiceNameBetween(String value1, String value2) {
            addCriterion("service_name between", value1, value2, "serviceName");
            return (Criteria) this;
        }

        public Criteria andServiceNameNotBetween(String value1, String value2) {
            addCriterion("service_name not between", value1, value2, "serviceName");
            return (Criteria) this;
        }

        public Criteria andSysRoleExtDataIdIsNull() {
            addCriterion("sys_role_ext_data_id is null");
            return (Criteria) this;
        }

        public Criteria andSysRoleExtDataIdIsNotNull() {
            addCriterion("sys_role_ext_data_id is not null");
            return (Criteria) this;
        }

        public Criteria andSysRoleExtDataIdEqualTo(Long value) {
            addCriterion("sys_role_ext_data_id =", value, "sysRoleExtDataId");
            return (Criteria) this;
        }

        public Criteria andSysRoleExtDataIdNotEqualTo(Long value) {
            addCriterion("sys_role_ext_data_id <>", value, "sysRoleExtDataId");
            return (Criteria) this;
        }

        public Criteria andSysRoleExtDataIdGreaterThan(Long value) {
            addCriterion("sys_role_ext_data_id >", value, "sysRoleExtDataId");
            return (Criteria) this;
        }

        public Criteria andSysRoleExtDataIdGreaterThanOrEqualTo(Long value) {
            addCriterion("sys_role_ext_data_id >=", value, "sysRoleExtDataId");
            return (Criteria) this;
        }

        public Criteria andSysRoleExtDataIdLessThan(Long value) {
            addCriterion("sys_role_ext_data_id <", value, "sysRoleExtDataId");
            return (Criteria) this;
        }

        public Criteria andSysRoleExtDataIdLessThanOrEqualTo(Long value) {
            addCriterion("sys_role_ext_data_id <=", value, "sysRoleExtDataId");
            return (Criteria) this;
        }

        public Criteria andSysRoleExtDataIdIn(List<Long> values) {
            addCriterion("sys_role_ext_data_id in", values, "sysRoleExtDataId");
            return (Criteria) this;
        }

        public Criteria andSysRoleExtDataIdNotIn(List<Long> values) {
            addCriterion("sys_role_ext_data_id not in", values, "sysRoleExtDataId");
            return (Criteria) this;
        }

        public Criteria andSysRoleExtDataIdBetween(Long value1, Long value2) {
            addCriterion("sys_role_ext_data_id between", value1, value2, "sysRoleExtDataId");
            return (Criteria) this;
        }

        public Criteria andSysRoleExtDataIdNotBetween(Long value1, Long value2) {
            addCriterion("sys_role_ext_data_id not between", value1, value2, "sysRoleExtDataId");
            return (Criteria) this;
        }

        public Criteria andSysRoleExtSampleIdIsNull() {
            addCriterion("sys_role_ext_sample_id is null");
            return (Criteria) this;
        }

        public Criteria andSysRoleExtSampleIdIsNotNull() {
            addCriterion("sys_role_ext_sample_id is not null");
            return (Criteria) this;
        }

        public Criteria andSysRoleExtSampleIdEqualTo(Long value) {
            addCriterion("sys_role_ext_sample_id =", value, "sysRoleExtSampleId");
            return (Criteria) this;
        }

        public Criteria andSysRoleExtSampleIdNotEqualTo(Long value) {
            addCriterion("sys_role_ext_sample_id <>", value, "sysRoleExtSampleId");
            return (Criteria) this;
        }

        public Criteria andSysRoleExtSampleIdGreaterThan(Long value) {
            addCriterion("sys_role_ext_sample_id >", value, "sysRoleExtSampleId");
            return (Criteria) this;
        }

        public Criteria andSysRoleExtSampleIdGreaterThanOrEqualTo(Long value) {
            addCriterion("sys_role_ext_sample_id >=", value, "sysRoleExtSampleId");
            return (Criteria) this;
        }

        public Criteria andSysRoleExtSampleIdLessThan(Long value) {
            addCriterion("sys_role_ext_sample_id <", value, "sysRoleExtSampleId");
            return (Criteria) this;
        }

        public Criteria andSysRoleExtSampleIdLessThanOrEqualTo(Long value) {
            addCriterion("sys_role_ext_sample_id <=", value, "sysRoleExtSampleId");
            return (Criteria) this;
        }

        public Criteria andSysRoleExtSampleIdIn(List<Long> values) {
            addCriterion("sys_role_ext_sample_id in", values, "sysRoleExtSampleId");
            return (Criteria) this;
        }

        public Criteria andSysRoleExtSampleIdNotIn(List<Long> values) {
            addCriterion("sys_role_ext_sample_id not in", values, "sysRoleExtSampleId");
            return (Criteria) this;
        }

        public Criteria andSysRoleExtSampleIdBetween(Long value1, Long value2) {
            addCriterion("sys_role_ext_sample_id between", value1, value2, "sysRoleExtSampleId");
            return (Criteria) this;
        }

        public Criteria andSysRoleExtSampleIdNotBetween(Long value1, Long value2) {
            addCriterion("sys_role_ext_sample_id not between", value1, value2, "sysRoleExtSampleId");
            return (Criteria) this;
        }

        public Criteria andSysOrgIdIsNull() {
            addCriterion("sys_org_id is null");
            return (Criteria) this;
        }

        public Criteria andSysOrgIdIsNotNull() {
            addCriterion("sys_org_id is not null");
            return (Criteria) this;
        }

        public Criteria andSysOrgIdEqualTo(Long value) {
            addCriterion("sys_org_id =", value, "sysOrgId");
            return (Criteria) this;
        }

        public Criteria andSysOrgIdNotEqualTo(Long value) {
            addCriterion("sys_org_id <>", value, "sysOrgId");
            return (Criteria) this;
        }

        public Criteria andSysOrgIdGreaterThan(Long value) {
            addCriterion("sys_org_id >", value, "sysOrgId");
            return (Criteria) this;
        }

        public Criteria andSysOrgIdGreaterThanOrEqualTo(Long value) {
            addCriterion("sys_org_id >=", value, "sysOrgId");
            return (Criteria) this;
        }

        public Criteria andSysOrgIdLessThan(Long value) {
            addCriterion("sys_org_id <", value, "sysOrgId");
            return (Criteria) this;
        }

        public Criteria andSysOrgIdLessThanOrEqualTo(Long value) {
            addCriterion("sys_org_id <=", value, "sysOrgId");
            return (Criteria) this;
        }

        public Criteria andSysOrgIdIn(List<Long> values) {
            addCriterion("sys_org_id in", values, "sysOrgId");
            return (Criteria) this;
        }

        public Criteria andSysOrgIdNotIn(List<Long> values) {
            addCriterion("sys_org_id not in", values, "sysOrgId");
            return (Criteria) this;
        }

        public Criteria andSysOrgIdBetween(Long value1, Long value2) {
            addCriterion("sys_org_id between", value1, value2, "sysOrgId");
            return (Criteria) this;
        }

        public Criteria andSysOrgIdNotBetween(Long value1, Long value2) {
            addCriterion("sys_org_id not between", value1, value2, "sysOrgId");
            return (Criteria) this;
        }

        public Criteria andSysVirtIdIsNull() {
            addCriterion("sys_virt_id is null");
            return (Criteria) this;
        }

        public Criteria andSysVirtIdIsNotNull() {
            addCriterion("sys_virt_id is not null");
            return (Criteria) this;
        }

        public Criteria andSysVirtIdEqualTo(Long value) {
            addCriterion("sys_virt_id =", value, "sysVirtId");
            return (Criteria) this;
        }

        public Criteria andSysVirtIdNotEqualTo(Long value) {
            addCriterion("sys_virt_id <>", value, "sysVirtId");
            return (Criteria) this;
        }

        public Criteria andSysVirtIdGreaterThan(Long value) {
            addCriterion("sys_virt_id >", value, "sysVirtId");
            return (Criteria) this;
        }

        public Criteria andSysVirtIdGreaterThanOrEqualTo(Long value) {
            addCriterion("sys_virt_id >=", value, "sysVirtId");
            return (Criteria) this;
        }

        public Criteria andSysVirtIdLessThan(Long value) {
            addCriterion("sys_virt_id <", value, "sysVirtId");
            return (Criteria) this;
        }

        public Criteria andSysVirtIdLessThanOrEqualTo(Long value) {
            addCriterion("sys_virt_id <=", value, "sysVirtId");
            return (Criteria) this;
        }

        public Criteria andSysVirtIdIn(List<Long> values) {
            addCriterion("sys_virt_id in", values, "sysVirtId");
            return (Criteria) this;
        }

        public Criteria andSysVirtIdNotIn(List<Long> values) {
            addCriterion("sys_virt_id not in", values, "sysVirtId");
            return (Criteria) this;
        }

        public Criteria andSysVirtIdBetween(Long value1, Long value2) {
            addCriterion("sys_virt_id between", value1, value2, "sysVirtId");
            return (Criteria) this;
        }

        public Criteria andSysVirtIdNotBetween(Long value1, Long value2) {
            addCriterion("sys_virt_id not between", value1, value2, "sysVirtId");
            return (Criteria) this;
        }

        public Criteria andOutOrgIdIsNull() {
            addCriterion("out_org_id is null");
            return (Criteria) this;
        }

        public Criteria andOutOrgIdIsNotNull() {
            addCriterion("out_org_id is not null");
            return (Criteria) this;
        }

        public Criteria andOutOrgIdEqualTo(Long value) {
            addCriterion("out_org_id =", value, "outOrgId");
            return (Criteria) this;
        }

        public Criteria andOutOrgIdNotEqualTo(Long value) {
            addCriterion("out_org_id <>", value, "outOrgId");
            return (Criteria) this;
        }

        public Criteria andOutOrgIdGreaterThan(Long value) {
            addCriterion("out_org_id >", value, "outOrgId");
            return (Criteria) this;
        }

        public Criteria andOutOrgIdGreaterThanOrEqualTo(Long value) {
            addCriterion("out_org_id >=", value, "outOrgId");
            return (Criteria) this;
        }

        public Criteria andOutOrgIdLessThan(Long value) {
            addCriterion("out_org_id <", value, "outOrgId");
            return (Criteria) this;
        }

        public Criteria andOutOrgIdLessThanOrEqualTo(Long value) {
            addCriterion("out_org_id <=", value, "outOrgId");
            return (Criteria) this;
        }

        public Criteria andOutOrgIdIn(List<Long> values) {
            addCriterion("out_org_id in", values, "outOrgId");
            return (Criteria) this;
        }

        public Criteria andOutOrgIdNotIn(List<Long> values) {
            addCriterion("out_org_id not in", values, "outOrgId");
            return (Criteria) this;
        }

        public Criteria andOutOrgIdBetween(Long value1, Long value2) {
            addCriterion("out_org_id between", value1, value2, "outOrgId");
            return (Criteria) this;
        }

        public Criteria andOutOrgIdNotBetween(Long value1, Long value2) {
            addCriterion("out_org_id not between", value1, value2, "outOrgId");
            return (Criteria) this;
        }

        public Criteria andOutVirtIdIsNull() {
            addCriterion("out_virt_id is null");
            return (Criteria) this;
        }

        public Criteria andOutVirtIdIsNotNull() {
            addCriterion("out_virt_id is not null");
            return (Criteria) this;
        }

        public Criteria andOutVirtIdEqualTo(Long value) {
            addCriterion("out_virt_id =", value, "outVirtId");
            return (Criteria) this;
        }

        public Criteria andOutVirtIdNotEqualTo(Long value) {
            addCriterion("out_virt_id <>", value, "outVirtId");
            return (Criteria) this;
        }

        public Criteria andOutVirtIdGreaterThan(Long value) {
            addCriterion("out_virt_id >", value, "outVirtId");
            return (Criteria) this;
        }

        public Criteria andOutVirtIdGreaterThanOrEqualTo(Long value) {
            addCriterion("out_virt_id >=", value, "outVirtId");
            return (Criteria) this;
        }

        public Criteria andOutVirtIdLessThan(Long value) {
            addCriterion("out_virt_id <", value, "outVirtId");
            return (Criteria) this;
        }

        public Criteria andOutVirtIdLessThanOrEqualTo(Long value) {
            addCriterion("out_virt_id <=", value, "outVirtId");
            return (Criteria) this;
        }

        public Criteria andOutVirtIdIn(List<Long> values) {
            addCriterion("out_virt_id in", values, "outVirtId");
            return (Criteria) this;
        }

        public Criteria andOutVirtIdNotIn(List<Long> values) {
            addCriterion("out_virt_id not in", values, "outVirtId");
            return (Criteria) this;
        }

        public Criteria andOutVirtIdBetween(Long value1, Long value2) {
            addCriterion("out_virt_id between", value1, value2, "outVirtId");
            return (Criteria) this;
        }

        public Criteria andOutVirtIdNotBetween(Long value1, Long value2) {
            addCriterion("out_virt_id not between", value1, value2, "outVirtId");
            return (Criteria) this;
        }

        public Criteria andDeletedIsNull() {
            addCriterion("deleted is null");
            return (Criteria) this;
        }

        public Criteria andDeletedIsNotNull() {
            addCriterion("deleted is not null");
            return (Criteria) this;
        }

        public Criteria andDeletedEqualTo(Integer value) {
            addCriterion("deleted =", value, "deleted");
            return (Criteria) this;
        }

        public Criteria andDeletedNotEqualTo(Integer value) {
            addCriterion("deleted <>", value, "deleted");
            return (Criteria) this;
        }

        public Criteria andDeletedGreaterThan(Integer value) {
            addCriterion("deleted >", value, "deleted");
            return (Criteria) this;
        }

        public Criteria andDeletedGreaterThanOrEqualTo(Integer value) {
            addCriterion("deleted >=", value, "deleted");
            return (Criteria) this;
        }

        public Criteria andDeletedLessThan(Integer value) {
            addCriterion("deleted <", value, "deleted");
            return (Criteria) this;
        }

        public Criteria andDeletedLessThanOrEqualTo(Integer value) {
            addCriterion("deleted <=", value, "deleted");
            return (Criteria) this;
        }

        public Criteria andDeletedIn(List<Integer> values) {
            addCriterion("deleted in", values, "deleted");
            return (Criteria) this;
        }

        public Criteria andDeletedNotIn(List<Integer> values) {
            addCriterion("deleted not in", values, "deleted");
            return (Criteria) this;
        }

        public Criteria andDeletedBetween(Integer value1, Integer value2) {
            addCriterion("deleted between", value1, value2, "deleted");
            return (Criteria) this;
        }

        public Criteria andDeletedNotBetween(Integer value1, Integer value2) {
            addCriterion("deleted not between", value1, value2, "deleted");
            return (Criteria) this;
        }
    }

    /**
     *
     * table sys_role_ext_data_sample_permission
     *
     * do_not_delete_during_merge Wed Aug 26 11:48:59 CST 2020
     */
    public static class Criteria extends GeneratedCriteria {
        protected Criteria() {
            super();
        }
    }

    /**
     *
     * table sys_role_ext_data_sample_permission
     *
     * Wed Aug 26 11:48:59 CST 2020
     */
    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}